明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2185|回复: 4

如何将用wblock命令导出的块添加到图纸中?

[复制链接]
发表于 2006-5-31 22:17:00 | 显示全部楼层 |阅读模式
我在一个dwg图纸中做好了所有的块,然后我用wblock命令将这些块保存成dwg文件,那么我在需要的时候就可以直接将这些块添加到我的其他的dwg文件中,可是在程序中如何实现插入以dwg格式存放在磁盘某个位置的块呢?
 楼主| 发表于 2006-6-2 17:35:00 | 显示全部楼层

问题我已经通过广大无私人事的帮助终于完满的解决了,再次公布出来给大家共同分享,同时感谢帮助我的朋友们!

Acad::ErrorStatus insertBolck(const char *blockName)
{
 //将块从文件读出,添加到当前数据库中
 AcDbDatabase *pNewDb =new AcDbDatabase(Adesk::kFalse);

 Acad::ErrorStatus es = pNewDb->readDwgFile("C:\\Documents and Settings\\pengsl\\My Documents\\ARX\\Step01\\TEL_CD.dwg" , _SH_DENYNO,false);
 if (es!=Acad::eOk)
 {
  acutPrintf("\nThe file  cannot be opend");
  return es;
 }

 AcDbDatabase *pDb =acdbHostApplicationServices()->workingDatabase ();
// pDb->insert(AcGeMatrix3d::kIdentity, pNewDb );这样添加的块是打散的 ,而且也没有自定义属性。
 
 AcDbObjectId blockId;
 
 if((es=pDb->insert(blockId, "TEL_CD",pNewDb, true))==Acad::eOk)
 {
  acutPrintf("\ninsert ok\n");
 }
 else
 {
  acutPrintf("\nInsert failed");
  delete pNewDb;
  return es;
 }

 //将块从当前数据库中添加到图纸中并且显示出来,此时块还不具备自定义属性
 AcGePoint3d ptOrg(10,10,0);
    AcGeScale3d XrefScale(10,10,1);

 AcDbObjectId blockTelCdId;
 AcDbBlockTable *pBlockTable;
 pDb->getSymbolTable(pBlockTable, AcDb::kForRead);
 pBlockTable->getAt("TEL_CD", blockTelCdId);

 AcDbBlockReference *pBlkRef = new AcDbBlockReference;
 
 pBlkRef->setBlockTableRecord(blockTelCdId);
 pBlkRef->setPosition(ptOrg);
 pBlkRef->setRotation(0.0);//设定转角
 pBlkRef->setScaleFactors(XrefScale);//设定放大比例

 AcDbBlockTableRecord *pBlockTableRecord;
 
 pBlockTable->getAt(ACDB_MODEL_SPACE, pBlockTableRecord, AcDb::kForWrite);
 pBlockTable->close();
 
 AcDbObjectId newEntId;
 
 if((es = pBlockTableRecord->appendAcDbEntity(newEntId, pBlkRef)) != Acad::eOk)
 {
  acutPrintf("\n something is wrong");
 }
 
 //处理新加块的自定义属性值
 AcDbBlockTableRecord *pBlockDef;
 acdbOpenObject(pBlockDef, blockTelCdId, AcDb::kForWrite);
 AcDbBlockTableRecordIterator *pIterator;
 pBlockDef->newIterator(pIterator);
 AcGePoint3d basePoint;
 AcDbEntity *pEnt;
 AcDbAttributeDefinition *pAttdef;
 
 for (pIterator->start(); !pIterator->done(); pIterator->step())//将source.dwg中所有的Attibute进行遍历
 {
        pIterator->getEntity(pEnt, AcDb::kForRead);
        pAttdef = AcDbAttributeDefinition::cast(pEnt);
      
  if (pAttdef != NULL && !pAttdef->isConstant())
  {
            AcDbAttribute *pAtt = new AcDbAttribute();
            pAtt->setPropertiesFrom(pAttdef);
            pAtt->setInvisible(pAttdef->isInvisible());
            basePoint = pAttdef->position();
            basePoint += pBlkRef->position().asVector();
            pAtt->setPosition(basePoint);
            pAtt->setHeight(pAttdef->height());
            pAtt->setRotation(pAttdef->rotation());
            pAtt->setTag("Tag");
            pAtt->setFieldLength(25);
            char *pStr = pAttdef->tag();
            pAtt->setTag(pStr);
   acutDelString(pStr);
            pAtt->setFieldLength(pAttdef->fieldLength());
            pAtt->setTextString("J001/zg01/003");
            AcDbObjectId attId;
            pBlkRef->appendAttribute(attId, pAtt);
            pAtt->close();
        }
        pEnt->close(); // use pEnt... pAttdef might be NULL
    }
 delete pIterator;
 
 pBlockDef->close();
 pBlockTableRecord->close();
 pBlkRef->close();

 delete pNewDb;
 return Acad::eOk;
}

发表于 2006-6-14 00:34:00 | 显示全部楼层

这个函数封装的太差劲了

 楼主| 发表于 2006-6-14 10:59:00 | 显示全部楼层

^_^,我也承认封装的很差,这个函数只是用来完成功能的,没有考虑其它很多

发表于 2006-6-14 13:38:00 | 显示全部楼层
jingelou发表于2006-6-14 0:34:00 这个函数封装的太差劲了

嫩为大家提供一个封装的较好的函数吗?
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 23:40 , Processed in 0.176816 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表